import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.text.*;
import java.sql.*;
/**
 * Vista correspondiente a la confirmacion de Factura
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class ConfirmadaView extends JPanel {  
    private JLabel lblmsg = null;
    private FacturaModel fm = new FacturaModel();
    private JTable tbl = new JTable(fm);
    private JScrollPane sp = new JScrollPane(tbl,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);  
    private JButton btnConf = new JButton("Confirmar");
    
    public ConfirmadaView() {
        this(null);
    }
    public ConfirmadaView(JLabel lmsg) {
        lblmsg = lmsg;
        setLayout(new BorderLayout());
        JPanel pinf = new JPanel();
        pinf.add(btnConf);
        add(sp,BorderLayout.CENTER);
        add(pinf,BorderLayout.SOUTH);
        btnConf.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    if ( tbl.getSelectedRow() != -1 ) {
                        FBCon f = FBCon.getFBCon(0);
                        FacturaQuery fq = fm.getFacturaQuery(tbl.getSelectedRow());
                        f.executeQuery("UPDATE TBL_FACTURA SET CONFIRMADA = 'S' WHERE NRO = "+fq.nro);
                        DecimalFormatSymbols ds = new DecimalFormatSymbols(Locale.getDefault());
                        ds.setDecimalSeparator('.');
                        DecimalFormat df = new DecimalFormat("#######0.00",ds);            
                        df.setMaximumFractionDigits(2);
                        df.setMinimumIntegerDigits(2);
                        df.setGroupingUsed(false);
                        String scli = "UPDATE TBL_CLIENTE SET SALDO = SALDO + "+df.format(fq.monto)+" WHERE IDC = "+fq.idc;
                        //System.out.println(scli);
                        f.executeQuery(scli);
                        ResultSet rs = f.getResultSet("SELECT IDP,CANTIDAD FROM TBL_DETALLE WHERE NRO = "+fq.nro);
                        Map<Integer,Integer> map = new HashMap<Integer,Integer>();
                        while(rs.next()) {
                            map.put(rs.getInt("idp"),rs.getInt("cantidad"));
                        }
                        f.close(rs);
                        for(Integer idp : map.keySet()) {
                            String sprod = "UPDATE TBL_PRODUCTO SET STOCK = STOCK - "+map.get(idp)+
                                " WHERE IDP = "+idp;
                            //System.out.println(sprod);
                            f.executeQuery(sprod);
                        }
                        fm.actualizar();
                    }
                } catch(SQLException sqle) {
                    lblmsg.setText("Error, "+sqle.getMessage());
                }
            }
        });
    }
    
}
