import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
/**
 * Ventana de Login inicial
 * Solo ingresamos usuario y contrasena
 * el resto de los datos de la conexion los vamos
 * a tomar de un archivo de configuracion de la 
 * aplicacion
 * 
 * @author G. Cherencio 
 * @version 1.0
 */
public class LoginView {
    private JFrame fr = new JFrame("Ingreso Sistema Facturacion");
    private JLabel lblUsr = new JLabel("Usuario:");
    private JLabel lblClave = new JLabel("Clave:");
    private JTextField txtUsr = new JTextField("sysdba");
    private JPasswordField txtClave = new JPasswordField();
    private JButton btnLogin = new JButton("Ingresar");
    private JButton btnSalir = new JButton("Salir");
    
    public LoginView() {
        // seleccionamos un Layout Manager
        JPanel plCentral = new JPanel();
        plCentral.setLayout(new GridLayout(6,2));
        plCentral.add(new JLabel(""));
        plCentral.add(new JLabel(""));
        plCentral.add(lblUsr);
        plCentral.add(txtUsr);
        plCentral.add(lblClave);
        plCentral.add(txtClave);
        plCentral.add(new JLabel(""));
        plCentral.add(new JLabel(""));
        plCentral.add(btnSalir);
        plCentral.add(btnLogin);
        
        // Inicializo datos globales de la aplicacion
        Util.clave = null;
        Util.usuario = null;
        Util.loginOk = false;
        
        // agregar eventos
        btnSalir.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // finalizo la aplicacion
                FBCon.closeAll();
                System.exit(0);
            }
        });
        btnLogin.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // validar el ingreso de usuario y contrasena
                if ( txtUsr.getText().length() == 0 ) {
                    JOptionPane.showMessageDialog(fr, "Debe Ingresar el Usuario para conectarse", "Sistema Facturacion - Error", JOptionPane.ERROR_MESSAGE);
                    txtUsr.requestFocus();
                }
                String clave = new String(txtClave.getPassword());
                if ( clave.length() == 0 ) {
                    JOptionPane.showMessageDialog(fr, "Debe Ingresar la Clave para conectarse", "Sistema Facturacion - Error", JOptionPane.ERROR_MESSAGE);
                    txtClave.requestFocus();
                }
                // el usuario ingreso clave y contrasenia
                // intento conexion a BD Firebird 2.5
                try {
                    Properties prop = new Properties();
                    prop.load(new FileInputStream(new File("sf.prop")));
                    FBCon fb = new FBCon(prop.getProperty("servidor")+"/"+prop.getProperty("puerto")+":"+prop.getProperty("base"),
                        txtUsr.getText(),clave,prop.getProperty("rol"));
                    if ( fb.getConnection() != null ) {
                        Util.loginOk = true;
                        Util.usuario = txtUsr.getText();
                        Util.clave = clave;
                        fr.hide(); // oculta la pantalla de login
                        new AppView();
                    } else {
                        JOptionPane.showMessageDialog(fr, "Usuario o Clave incorrecta", "Sistema Facturacion - Error", JOptionPane.ERROR_MESSAGE);
                    }
                } catch(IOException ioe) {
                    JOptionPane.showMessageDialog(fr, "Error: "+ioe.getMessage(), "Sistema Facturacion - Error", JOptionPane.ERROR_MESSAGE);
                }
                
            }
        });
        
        fr.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent windowEvent) {
                FBCon.closeAll();
                System.exit(0);
            }
        });        
        
        fr.setLayout(new BorderLayout());
        fr.add(plCentral,BorderLayout.CENTER);
        fr.setSize(400,200);
        fr.setResizable(false);
        fr.setLocationRelativeTo(null); // centramos pantalla
        fr.setVisible(true);
        txtClave.requestFocus();
    }
    
    public static void main(String[] arg) {
        new LoginView();
    }

}
