import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.text.*;
import java.sql.*;
/**
 * Vista correspondiente al pago de Factura
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class PagadaView extends JPanel {  
    private JLabel lblmsg = null;
    private String squery = "SELECT F.NRO, F.FECHA, C.IDC, C.DESCR, F.CONFIRMADA, F.PAGADA, F.MONTO "+
             "FROM TBL_FACTURA F INNER JOIN TBL_CLIENTE C ON F.CLIENTE = C.IDC "+
             "WHERE F.CONFIRMADA = 'S' AND F.PAGADA = 'N' ORDER BY F.NRO ASC";
    private FacturaModel fm = new FacturaModel(squery);
    private JTable tbl = new JTable(fm);
    private JScrollPane sp = new JScrollPane(tbl,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);  
    private JButton btnConf = new JButton("Pagar");
    
    public PagadaView() {
        this(null);
    }
    public PagadaView(JLabel lmsg) {
        lblmsg = lmsg;
        setLayout(new BorderLayout());
        JPanel pinf = new JPanel();
        pinf.add(btnConf);
        add(sp,BorderLayout.CENTER);
        add(pinf,BorderLayout.SOUTH);
        btnConf.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    if ( tbl.getSelectedRow() != -1 ) {
                        FBCon f = FBCon.getFBCon(0);
                        FacturaQuery fq = fm.getFacturaQuery(tbl.getSelectedRow());
                        f.executeQuery("UPDATE TBL_FACTURA SET PAGADA = 'S' WHERE NRO = "+fq.nro);
                        DecimalFormatSymbols ds = new DecimalFormatSymbols(Locale.getDefault());
                        ds.setDecimalSeparator('.');
                        DecimalFormat df = new DecimalFormat("#######0.00",ds);            
                        df.setMaximumFractionDigits(2);
                        df.setMinimumIntegerDigits(2);
                        df.setGroupingUsed(false);
                        String scli = "UPDATE TBL_CLIENTE SET SALDO = SALDO - "+df.format(fq.monto)+" WHERE IDC = "+fq.idc;
                        f.executeQuery(scli);
                        fm.actualizar();
                    }
                } catch(SQLException sqle) {
                    lblmsg.setText("Error, "+sqle.getMessage());
                }
            }
        });
    }
    
}
